# VillagerOptimizer
## Combat server lag caused by large amounts of villagers

This plugin enables you and your playerbase to optimize villagers in trading halls or other setups so they still remain their function but don't take up large amounts of resources.

There are 4 methods to do so:

- Using commands to optimize/unoptimize all villagers in a given block radius
- Using nametags with a specific name to optimize/unoptimize a single villager (recommended)
- Using specific blocks and placing/removing them near a villager
- Using the corresponding workstation block and placing/removing them near a villager

It aims to be highly customizable and performant. Offering a multilang system, which displays messages based on the player client's language setting as well as an optimize- and unoptimize event, so you may extend the plugin with your own custom solutions.

Other features:
- Prevent trading with unoptimized villagers to encourage players to optimize them
- Smart villager chunk limit with configurable max numbers for optimized and unoptimized villagers and a villager profession based priorisation system (you can configure what kind of villagers should be deleted first, like for example nitwits or jobless villagers.)
- Make villagers spawn as adults so players can optimize them sooner
- Prevent other mobs from targeting optimized villagers
- Prevent damage of specific, configurable causes to optimized villagers
- Comes with prepackaged translations for en_us, de_de, it_it, ru_ru
- All plugin messages support the usage of multiple lines and use MiniMessage formatting. This means you can use hex colors, custom click events and much more without needing to be a programmer!


### Found a bug or got an idea for an enhancement? Open an issue or join the [discord](https://discord.com/invite/3UgsYf3qyc)!


# Important:
### The 1.16 version is meant to be used on Paper servers 1.16-1.19.4
### The 1.20.2 version is meant to be used on Paper 1.20+ and Folia 1.19.4+ servers
